{-# OPTIONS --allow-unsolved-metas #-}

module Exam.Part3.Composition where

open import Data.Product
open import Data.Sum
open import Data.Nat using (ℕ; zero; suc; _+_)
open import Function using (_∘_)
open import Relation.Binary.PropositionalEquality using (_≡_; refl; sym; subst; cong; cong₂; module ≡-Reasoning)
open import Data.Fin using (zero; suc) renaming (Fin to 𝔽)
open import Relation.Nullary using (¬_)
open import Data.Empty using (⊥; ⊥-elim)

open import Exam.Part3.Specification

--------------------------------------------------------------------------------

-- Composition of two renamings

_∘ᵣᵣ_ : ∀ {n₁ n₂ n₃} → Ren n₂ n₃ → Ren n₁ n₂ → Ren n₁ n₃
(ρ₁ ∘ᵣᵣ ρ₂) x = ρ₁ (ρ₂ x)

ext-dist-∘ᵣᵣ : ∀ {n₁ n₂ n₃} (ρ₁ : Ren n₂ n₃) (ρ₂ : Ren n₁ n₂)
  → extᵣ (ρ₁ ∘ᵣᵣ ρ₂) ≡ (extᵣ ρ₁) ∘ᵣᵣ (extᵣ ρ₂)
ext-dist-∘ᵣᵣ = {!!}

fusion-∘ᵣᵣ : ∀ {n₁ n₂ n₃} (ρ₁ : Ren n₂ n₃) (ρ₂ : Ren n₁ n₂) (e : Term n₁)
  → ren ρ₁ (ren ρ₂ e) ≡ ren (ρ₁ ∘ᵣᵣ ρ₂) e
fusion-∘ᵣᵣ = {!!}

wk-extᵣ : ∀ {m n} (ρ : Ren m n)
  → wk ∘ᵣᵣ ρ ≡ extᵣ ρ ∘ᵣᵣ wk
wk-extᵣ = {!!}

wk-extᵣ-fusion : ∀ {m n} (ρ : Ren m n) (e : Term m)
  → ren wk (ren ρ e) ≡ ren (extᵣ ρ) (ren wk e)
wk-extᵣ-fusion = {!!}

--------------------------------------------------------------------------------

-- Composition of a substitution and a renaming

_∘ₛᵣ_ : ∀ {n₁ n₂ n₃} → Sub n₂ n₃ → Ren n₁ n₂ → Sub n₁ n₃
(σ₁ ∘ₛᵣ ρ₂) x = σ₁ (ρ₂ x)

ext-dist-∘ₛᵣ : ∀ {n₁ n₂ n₃} (σ₁ : Sub n₂ n₃) (ρ₂ : Ren n₁ n₂)
  → extₛ (σ₁ ∘ₛᵣ ρ₂) ≡ (extₛ σ₁) ∘ₛᵣ (extᵣ ρ₂)
ext-dist-∘ₛᵣ = {!!}

fusion-∘ₛᵣ : ∀ {n₁ n₂ n₃} (σ₁ : Sub n₂ n₃) (ρ₂ : Ren n₁ n₂) (e : Term n₁)
  → sub σ₁ (ren ρ₂ e) ≡ sub (σ₁ ∘ₛᵣ ρ₂) e
fusion-∘ₛᵣ = {!!}

--------------------------------------------------------------------------------

-- Composition of a renaming and a substitution

_∘ᵣₛ_ : ∀ {n₁ n₂ n₃} → Ren n₂ n₃ → Sub n₁ n₂ → Sub n₁ n₃
(ρ₁ ∘ᵣₛ σ₂) x = ren ρ₁ (σ₂ x)

ext-dist-∘ᵣₛ : ∀ {n₁ n₂ n₃} (ρ₁ : Ren n₂ n₃) (σ₂ : Sub n₁ n₂)
  → extₛ (ρ₁ ∘ᵣₛ σ₂) ≡ (extᵣ ρ₁) ∘ᵣₛ (extₛ σ₂)
ext-dist-∘ᵣₛ = {!!}

fusion-∘ᵣₛ : ∀ {n₁ n₂ n₃} (ρ₁ : Ren n₂ n₃) (σ₂ : Sub n₁ n₂) (e : Term n₁)
  → ren ρ₁ (sub σ₂ e) ≡ sub (ρ₁ ∘ᵣₛ σ₂) e
fusion-∘ᵣₛ = {!!}

wk-extₛ : ∀ {m n} (σ : Sub m n)
  → wk ∘ᵣₛ σ ≡ extₛ σ ∘ₛᵣ wk
wk-extₛ = {!!}

wk-extₛ-fusion : ∀ {m n} (σ : Sub m n) (e : Term m)
  → ren wk (sub σ e) ≡ sub (extₛ σ) (ren wk e)
wk-extₛ-fusion = {!!}

--------------------------------------------------------------------------------

-- Composition of two substitutions

_∘ₛₛ_ : ∀ {n₁ n₂ n₃} → Sub n₂ n₃ → Sub n₁ n₂ → Sub n₁ n₃
(σ₁ ∘ₛₛ σ₂) x = sub σ₁ (σ₂ x)

ext-dist-∘ₛₛ : ∀ {n₁ n₂ n₃} (σ₁ : Sub n₂ n₃) (σ₂ : Sub n₁ n₂)
  → extₛ (σ₁ ∘ₛₛ σ₂) ≡ (extₛ σ₁) ∘ₛₛ (extₛ σ₂)
ext-dist-∘ₛₛ = {!!}

fusion-∘ₛₛ : ∀ {n₁ n₂ n₃} (σ₁ : Sub n₂ n₃) (σ₂ : Sub n₁ n₂) (e : Term n₁)
  → sub σ₁ (sub σ₂ e) ≡ sub (σ₁ ∘ₛₛ σ₂) e
fusion-∘ₛₛ = {!!}

--------------------------------------------------------------------------------

-- Identity substitution does nothing

idₛ : ∀ {n} → Sub n n
idₛ x = ` x

extₛ-idₛ : ∀ {n} →
  extₛ (idₛ {n}) ≡ idₛ {suc n}
extₛ-idₛ = {!!}

sub-id : ∀ {n} (e : Term n)
  → sub idₛ e ≡ e
sub-id = {!!}

--------------------------------------------------------------------------------

-- Weakening cancels singleton-substitution

wk-0↦ : ∀ {n} (e : Term n)
  → 0↦ e ∘ₛᵣ wk ≡ idₛ
wk-0↦ = {!!}

wk-0↦-fusion : ∀ {n} (e : Term n) (e' : Term n)
  → sub (0↦ e) (ren wk e') ≡ e'
wk-0↦-fusion = {!!}

--------------------------------------------------------------------------------

-- Swap singleton-substitution with renaming

swap-0↦-extᵣ : ∀ {m n} (ρ : Ren m n) (e : Term m)
  → (0↦ (ren ρ e)) ∘ₛᵣ (extᵣ ρ)  ≡ ρ ∘ᵣₛ (0↦ e)
swap-0↦-extᵣ = {!!}

swap-0↦-extᵣ-fusion : ∀ {m n} (ρ : Ren m n) (e : Term m) (e' : Term (suc m)) 
  → sub (0↦ (ren ρ e)) (ren (extᵣ ρ) e') ≡ ren ρ (sub (0↦ e) e')
swap-0↦-extᵣ-fusion = {!!}

-- Swap singleton-substitution with substitution

swap-0↦-extₛ : ∀ {m n} (σ : Sub m n) (e : Term m)
  → (0↦ (sub σ e)) ∘ₛₛ (extₛ σ)  ≡ σ ∘ₛₛ (0↦ e)
swap-0↦-extₛ σ e = {!!}

swap-0↦-extₛ-fusion : ∀ {m n} (σ : Sub m n) (e : Term m) (e' : Term (suc m)) 
  → sub (0↦ (sub σ e)) (sub (extₛ σ) e') ≡ sub σ (sub (0↦ e) e')
swap-0↦-extₛ-fusion = {!!}
