{-# OPTIONS --allow-unsolved-metas #-}

module Exam.Part3.Inversion where

open import Data.Product renaming (_,_ to ⟨_,_⟩)
open import Data.Sum
open import Data.Nat using (ℕ; zero; suc; _+_)
open import Function using (_∘_)
open import Relation.Binary.PropositionalEquality using (_≡_; refl; sym; subst; cong; cong₂; module ≡-Reasoning)
open import Data.Fin using (zero; suc) renaming (Fin to 𝔽)
open import Relation.Nullary using (¬_)
open import Data.Empty using (⊥; ⊥-elim)

open import Exam.Part3.Specification
open import Exam.Part3.ConversionProperties using (≈-refl; ≈-trans; ≈-sym)

--------------------------------------------------------------------------------

-- Inversion for lambda terms

↪-∀-shape : ∀ {n} {t t₁ : Term n} {t₂ : Term (suc n)} →
  ∀[x⦂ t₁ ] t₂ ↪ t → 
  ∃[ t₁' ] ∃[ t₂' ] t ≡ ∀[x⦂ t₁' ] t₂' × (t₁ ↪* t₁') × (t₂ ↪* t₂')
↪-∀-shape = {!!}

↪*-∀-shape : ∀ {n} {t t₁ : Term n} {t₂ : Term (suc n)} →
  (∀[x⦂ t₁ ] t₂) ↪* t → 
  ∃[ t₁' ] ∃[ t₂' ] t ≡ ∀[x⦂ t₁' ] t₂' × (t₁ ↪* t₁') × (t₂ ↪* t₂')
↪*-∀-shape = {!!}

invert-≈-∀ : ∀ {n} {t₁ t₁' : Term n} {t₂ t₂' : Term (suc n)} →
  (∀[x⦂ t₁ ] t₂) ≈ (∀[x⦂ t₁' ] t₂') →
  t₁ ≈ t₁' × t₂ ≈ t₂'
invert-≈-∀ = {!!}

invert-⊢λ' : ∀ {n} {Γ : Context n} {e : Term (suc n)} {t : Term n} →
  Γ ⊢ `λ e ⦂ t →
  ∃[ t₁ ] ∃[ t₂ ]
    t ≈ (∀[x⦂ t₁ ] t₂) ×
    Γ ⊢ t₁ ⦂ `Set ×
    Γ , t₁ ⊢ e ⦂ t₂
invert-⊢λ' = {!!}

invert-⊢λ : ∀ {n} {Γ : Context n} {e : Term (suc n)} {t₁ : Term n} {t₂ : Term (suc n)}
  → Γ ⊢ `λ e ⦂ ∀[x⦂ t₁ ] t₂
  → ∃[ t₁' ] ∃[ t₂' ]
      t₁ ≈ t₁' ×
      t₂ ≈ t₂' ×
      Γ ⊢ t₁' ⦂ `Set ×
      Γ , t₁' ⊢ e ⦂ t₂'
invert-⊢λ = {!!}
