{-# OPTIONS --allow-unsolved-metas #-}

module Exam.Part3.SubstitutionPreservesTyping where

open import Data.Product renaming (_,_ to ⟨_,_⟩)
open import Data.Sum
open import Data.Nat using (ℕ; zero; suc; _+_)
open import Function using (_∘_)
open import Relation.Binary.PropositionalEquality using (_≡_; refl; sym; subst; cong; cong₂; module ≡-Reasoning)
open import Data.Fin using (zero; suc) renaming (Fin to 𝔽)
open import Relation.Nullary using (¬_)
open import Data.Empty using (⊥; ⊥-elim)

open import Exam.Part3.Specification
open import Exam.Part3.ConversionProperties using (≈-ren; ≈-sub)
open import Exam.Part3.Composition using (wk-extᵣ-fusion; swap-0↦-extᵣ-fusion; wk-extₛ-fusion; swap-0↦-extₛ-fusion; wk-0↦-fusion)

-- Renaming Typings

infix 4 _⦂_⇒ᵣ_

_⦂_⇒ᵣ_ : ∀ {m n} → Ren m n → Context m → Context n → Set
ρ ⦂ Γ₁ ⇒ᵣ Γ₂ = ∀ x → lookup Γ₂ (ρ x) ≡ ren ρ (lookup Γ₁ x)

⊢extᵣ : ∀ {m n t ρ} {Γ₁ : Context m} {Γ₂ : Context n}
  → ρ      ⦂ Γ₁     ⇒ᵣ Γ₂ 
  → extᵣ ρ ⦂ Γ₁ , t ⇒ᵣ Γ₂ , (ren ρ t)
⊢extᵣ = {!!}

⊢ren : ∀ {m n} {Γ₁ : Context m} {Γ₂ : Context n} {e t ρ}
  → ρ ⦂ Γ₁ ⇒ᵣ Γ₂ 
  → Γ₁ ⊢ e ⦂ t
  ------------------------
  → Γ₂ ⊢ ren ρ e ⦂ ren ρ t
⊢ren = {!!}
      
⊢wk : ∀ {n} {Γ : Context n} {t : Term n}
  → wk ⦂ Γ ⇒ᵣ (Γ , t)
⊢wk = {!!}

-- Substitution Typings

infix 4 _⦂_⇒ₛ_

_⦂_⇒ₛ_ : ∀ {m n} → Sub m n → Context m → Context n → Set
σ ⦂ Γ₁ ⇒ₛ Γ₂ = ∀ x → Γ₂ ⊢ σ x ⦂ sub σ (lookup Γ₁ x)

⊢extₛ : ∀ {m n σ} {t : Term m} {Γ₁ : Context m} {Γ₂ : Context n}
  → σ      ⦂ Γ₁     ⇒ₛ Γ₂ 
  → extₛ σ ⦂ Γ₁ , t ⇒ₛ Γ₂ , (sub σ t)
⊢extₛ = {!!}

⊢sub : ∀ {m n} {Γ₁ : Context m} {Γ₂ : Context n} {e t σ}
  → σ ⦂ Γ₁ ⇒ₛ Γ₂ 
  → Γ₁ ⊢ e ⦂ t
  ------------------------
  → Γ₂ ⊢ sub σ e ⦂ sub σ t
⊢sub = {!!}

⊢sub₁ : ∀ {n} {Γ : Context n} {e : Term n} {t}
  → Γ ⊢ e ⦂ t
  → 0↦ e ⦂ Γ , t ⇒ₛ Γ
⊢sub₁ = {!!}
